--Outrun
--By Callmore
--and i guess angular now

--##########
--###VARS###
--##########
local STARTTIME = 6*TICRATE + (3*TICRATE/4)
rawset(_G, "outrun", {
	gamemodestop = false,
	currentleader = nil,
	currentfirst = nil,
	changedleader = false,
	changedfirst = false,
	running = true,
	soundlasttic = false,
	endtime = nil,
	playedovertimesound = false,
	exittimer = 0,
	perfectwin = false
})

local skinRankIcons = {}
local m_norank = nil
local bignumGfx = {}

--###############
--###CONSTANTS###
--###############
local FIRSTXPOS = 10
local FIRSTYPOS = 80

local LEADERXPOS = 10
local LEADERYPOS = 101

local PERFECTRAINBOW = {V_REDMAP, V_YELLOWMAP, V_GREENMAP, V_SKYMAP, V_BLUEMAP, V_PURPLEMAP}

local OVERTIMELEVEL =  {"DOUBLE", "TRIPLE", "QUADRUPLE", "QUINTUPLE", "WHY IS THIS STILL IN"}

--###########
--###CVARS###
--###########
local cv_outrun_enabled = CV_RegisterVar{
	name = "frontrun_enabled",
	defaultvalue = "Yes",
	flags = CV_NETVAR,
	PossibleValue = CV_YesNo
}
local cv_outrun_timer = CV_RegisterVar{
	name = "frontrun_timer",
	defaultvalue = 60,
	flags = CV_NETVAR,
	PossibleValue = {MIN=5, MAX=5999}
}
local cv_outrun_respawnpenalty = CV_RegisterVar{
	name = "frontrun_respawnpenalty",
	defaultvalue = 5,
	flags = CV_NETVAR,
	PossibleValue = {MIN=0, MAX=5999}
}
local cv_outrun_suddendeathseconds = CV_RegisterVar{
	name = "frontrun_suddendeathseconds",
	defaultvalue = 180,
	flags = CV_NETVAR,
	PossibleValue = {MIN=0, MAX=5999}
}
local cv_outrun_suddendeathupgradeseconds = CV_RegisterVar{
	name = "frontrun_suddendeathupgradeseconds",
	defaultvalue = 60,
	flags = CV_NETVAR,
	PossibleValue = {MIN=1, MAX=5999}
}
local cv_outrun_minimumtimer = CV_RegisterVar{
	name = "frontrun_minimumtimer",
	defaultvalue = 10,
	flags = CV_NETVAR,
	PossibleValue = {MIN=0, MAX=5999}
}
local cv_outrun_comebackmintime = CV_RegisterVar{
	name = "frontrun_comebackmintime",
	defaultvalue = 10,
	flags = CV_NETVAR,
	PossibleValue = {MIN=1, MAX=5999}
}
local cv_outrun_comebackmaxtime = CV_RegisterVar{
	name = "frontrun_comebackmaxtime",
	defaultvalue = 30,
	flags = CV_NETVAR,
	PossibleValue = {MIN=1, MAX=5999}
}
local cv_outrun_comebackmaxspeed = CV_RegisterVar{
	name = "frontrun_comebackmaxspeed",
	defaultvalue = 12,
	flags = CV_NETVAR,
	PossibleValue = {MIN=1, MAX=1000}
}
local cv_outrun_comebackaccelfactor = CV_RegisterVar{
	name = "frontrun_comebackaccelfactor",
	defaultvalue = 8,
	flags = CV_NETVAR,
	PossibleValue = {MIN=0, MAX=100}
}
local cv_outrun_comeback = CV_RegisterVar{
	name = "frontrun_comeback",
	defaultvalue = "Yes",
	flags = CV_NETVAR,
	PossibleValue = CV_YesNo
}

--###############
--###FUNCTIONS###
--###############
local function calculateTimer()
	return abs(cv_outrun_suddendeathseconds.value*TICRATE-max(leveltime-STARTTIME, 0))
end

local function ticsToTimeString(t)
	
	if t >= TICRATE*60 then
		return string.format("%2d:%02d", min(G_TicsToMinutes(t, true), 99), G_TicsToSeconds(t))
	else
		return string.format("%02d.%02d", G_TicsToSeconds(t), G_TicsToCentiseconds(t))
	end
end

local function exitEveryone(winner)
	local isperfect = winner.outrun.perfect and (winner.outrun.ticsinfirst >= (cv_outrun_timer.value*TICRATE)/2)
	
	if isperfect then
		outrun.perfectwin = true
	end
	
	--il figgure out music in the future
	--seems like a huge pain
	for p in players.iterate do
		if p.valid and not p.spectator then
			if isperfect and p ~= winner then
				p.lives = 0
				p.pflags = $|PF_TIMEOVER
				P_DamageMobj(p.mo, nil, nil, 10000)
				S_ChangeMusic("KRLOSE", true, p)
				continue
			end
			P_DoPlayerExit(p)
		end
	end
	outrun.exittimer = 1
end

local function resetVars(p)
	p.outrun = {
		timer = cv_outrun_timer.value*TICRATE,
		ticsinfirst = 0,
		ticsinfirstreset = 0,
		perfect = true,
		speedbonus = 0 --recalculating this would be stupid, just save it and display on hud instead
	}
end

local function getStringColours(tics)
	if tics >= cv_outrun_minimumtimer.value*TICRATE then
		return 0
	end
	if (leveltime/4)%2 then
		return V_ORANGEMAP
	else
		return V_YELLOWMAP
	end
	return 0 --backup for incase
end

local function removePerfect(p)
	if p.valid and p.outrun and p.outrun.perfect then
		p.outrun.perfect = false
	end
end

--[[

ang thing - tactile vfx expressing speed boosts.

heavy wip so here's a bullshit lazy version lol

]]

local function comebackVfx(p, diff) --diff is the difference between base speed, we'll use that to adjust intensity
	local ghost = P_SpawnGhostMobj(p.mo)
	local ghostlen = ghost.info.damage
	local ghostspeed = (cv_outrun_comebackmaxspeed.value*FRACUNIT)/100
	ghost.fuse = FixedInt(FixedMul(ghostlen*FRACUNIT, FixedDiv(diff, ghostspeed)))+1
	ghost.colorized = true
end

--####################
--###HOOK FUNCTIONS###
--####################
--NetVars
local function netVars(net)
	outrun = net($)
end

--MapChange
local function outrunMapChange()
	
	outrun.gamemodestop = false
	for p in players.iterate do
		if not p.valid then continue end
		resetVars(p)
	end
	
	outrun.currentleader = nil
	outrun.currentfirst = nil
	outrun.endtime = nil
	outrun.playedovertimesound = false
	outrun.exittimer = 0
	outrun.perfectwin = false
	
	if (outrun.running and not cv_outrun_enabled.value) then
		hud.enable("minirankings")
		hud.enable("gametypeinfo")
		COM_BufInsertText(server, "numlaps " .. mapheaderinfo[gamemap].numlaps)
		COM_BufInsertText(server, 'basenumlaps "Map default"')
	end
	
	if G_BattleGametype() then
		outrun.running = false
	else
		outrun.running = cv_outrun_enabled.value
	end
	
	if outrun.running then
		hud.disable("minirankings")
		hud.disable("gametypeinfo")
		COM_BufInsertText(server, "numlaps 50")
		COM_BufInsertText(server, "basenumlaps 50")
	end
end

--ThinkFrame
local function outrunThink()
	
	if leveltime < 1 then return end
	if leveltime == 1 then outrunMapChange() end
	
	for p in players.iterate do --LETS JUST HOPE THIS STOPS SOME RESYNCS
		if not p.valid then continue end
		if not p.outrun then
			resetVars(p)
		end
	end
	
	if not outrun.running then return end
	
	--count players
	local plrs = 0
	for p in players.iterate do
		if p and p.valid and not p.spectator then
			plrs = $+1
		end
	end
	
	--stop gamemode if not enough players
	if plrs <= 1 and leveltime > TICRATE then
		hud.enable("minirankings")
		hud.enable("gametypeinfo")
		if not server then return end
		COM_BufInsertText(server, "numlaps " .. mapheaderinfo[gamemap].numlaps)
		COM_BufInsertText(server, 'basenumlaps "Map default"')
		outrun.running = false
		print("Frontrun disabled, not enough players")
	end
	
	--exitlevel if section race (sporint)
	if mapheaderinfo[gamemap].levelflags & LF_SECTIONRACE and leveltime > 3 then
		print("Outrun does not support sprint maps, exiting...")
		G_ExitLevel() --hey cool, thanks elimination
	end
	
	--reset if someones changed place this tic
	outrun.changedleader = false
	outrun.changedfirst = false
	
	--exit animation incrementer
	if outrun.exittimer then
		outrun.exittimer = $+1
		--if the exittimer is at 2*TICRATE (2 seconds)
		--it will display PERFECT if perfect game
		
		--its a good idea to put the sound here since
		--it will only ever play once
		if outrun.exittimer == 2*TICRATE and outrun.perfectwin then
			--play the sound
			--exsept i dont know what sound to play
			S_StartSound(nil, sfx_kc48)
			--this will do
		end
		
		--make sure that if the player leaves,
		--we exitlevel to stop server softlock
		if not outrun.currentleader.valid and outrun.exittimer >= TICRATE*5 then
			G_ExitLevel()
		end
		
		for p in players.iterate do
			if p.valid and not p.spectator then
				p.realtime = p.outrun.timer
			end
		end
		return
	end
	
	--anything beond here win never run if gamemode has ended
	
	--main loop
	for p in players.iterate do
		if not p.valid then continue end
		
		--setup a player if they arent setup yet
		if not p.outrun then
			resetVars(p)
		end
		
		--you dont need to check for valid if you already check for valid
		if not p.spectator then
			
			if leveltime <= STARTTIME and p.outrun.timer ~= cv_outrun_timer.value*TICRATE then --it doesnet?
				p.outrun.timer = cv_outrun_timer.value*TICRATE --guess what
			end --it now does
			
			--reset players on-screen timer to their outrun timer
			p.realtime = p.outrun.timer
			
			--main game code
			if leveltime > STARTTIME and not outrun.gamemodestop then
				
				if p.kartstuff[k_position] > 1
				and p.outrun.timer < TICRATE*cv_outrun_minimumtimer.value
				and not p.exiting then
					--reincrement timer if not in first
					p.outrun.timer = $+1
					
				elseif p.kartstuff[k_position] == 1
				and p.outrun.timer > 0
				and not p.kartstuff[k_respawn]
				and not health then
					--decrement timer if in first
					local sdtics = cv_outrun_suddendeathseconds.value*TICRATE
					local sdmult = 1
					local curtime = leveltime-STARTTIME
					if curtime > sdtics then
						sdmult = ((curtime-sdtics)/(TICRATE*cv_outrun_suddendeathupgradeseconds.value))+2
					end
					
					p.outrun.ticsinfirst = $+1
					p.outrun.ticsinfirstreset = TICRATE*5
					
					--huge hack to make it always play the sound
					for i = 1, sdmult do
						p.outrun.timer = max($-1, 0)
						
						--sounds ayyy
						if not outrun.soundlasttic then
							--stop it from doing sound every tic for some cases
							if p.outrun.timer <= TICRATE*10
							and p.outrun.timer
							and not (p.outrun.timer%TICRATE) then
								S_StartSound(nil, sfx_kc39)
								outrun.soundlasttic = true
							end
							
						elseif p.outrun.timer%TICRATE then
							outrun.soundlasttic = false
						end
					end
					
					--first changing
					if outrun.currentfirst == p then
						outrun.changedfirst = true
					elseif outrun.currentfirst ~= p
					and not outrun.changedfirst then
						outrun.currentfirst = p
						outrun.changedfirst = true
					end
					
					--leader detection
					if (outrun.currentleader and outrun.currentleader.valid) then
						if outrun.currentleader == p then
							outrun.changedleader = true
						elseif p.outrun.timer < outrun.currentleader.outrun.timer
						and outrun.currentleader ~= p
						and not outrun.changedleader then
							outrun.currentleader = p
							outrun.changedleader = true
						end
					else
						outrun.currentleader = p
					end
				end
				
				if not p.outrun.timer and not outrun.gamemodestop then
					exitEveryone(p)
					outrun.gamemodestop = true
					outrun.endtime = calculateTimer()
				end
				
				--reduce players ticsinfirst if they have any
				if p.outrun.ticsinfirstreset and outrun.currentfirst ~= p then
					p.outrun.ticsinfirstreset = $-1
					if not p.outrun.ticsinfirstreset then
						if p.outrun.perfect
						and p.outrun.ticsinfirst + p.outrun.timer > cv_outrun_timer.value*TICRATE - 5*TICRATE then
							p.outrun.perfect = false
						end
						
						p.outrun.ticsinfirst = 0
					end
				end
			end -- end main game block
		elseif p.spectator then
			--reset vars if the player is in spectator
			--and somehow is in first or is leader
			if outrun.currentfirst == p then
				outrun.currentfirst = nil
			end
			if outrun.currentleader == p then
				outrun.currentleader = nil
			end
		end
	end
	
	--the speed bonus has to be after the main loop
	--because it uses the currentleader variable
	--which gets set said main loop
	--you know what lets just quickly check that the leader even exsists cause im scared
	if cv_outrun_comeback.value and outrun.currentleader then
		if cv_outrun_comebackmintime.value >= cv_outrun_comebackmaxtime.value then return end
		local leadertimer = outrun.currentleader.outrun.timer
		local mincbtime = cv_outrun_comebackmintime.value
		local maxcbtime = cv_outrun_comebackmaxtime.value
		local cbtimedif = maxcbtime - mincbtime
		for p in players.iterate do
			if not p.valid then continue end
			--right thats the basis of the loop
			--all players from now on are both valid and playing
			if p.spectator and p.outrun then
				p.outrun.speedbonus = 0
				removePerfect(p)
			elseif p == outrun.currentleader then
				p.outrun.speedbonus = 0
			elseif (p.outrun.timer - leadertimer) > mincbtime*TICRATE then
				--player is more than 10 seconds behind first
				--calculate boost to give
				
				--WOW I ALMOST FUCKED THAT UP SUPER HARD
				--I WAS USING FRACUNIT INSTEAD OF TICRATE
				
				--time behind will be a number between 10*TICRATE and 30*TICRATE
				--then 10*TICRATE is taken off, resulting with a value between 0 and 20*TICRATE
				local timebehind = min(max(p.outrun.timer - leadertimer, mincbtime*TICRATE), maxcbtime*TICRATE)-mincbtime*TICRATE
				
				--FixedDiv doesent care if the value is in FRACUNIT or not in reality
				--its super useful for these cases
				local speedbonus = FixedDiv(timebehind, cbtimedif*TICRATE)
				--since k_speedboost expects a number as a FRACUNIT percentage
				--il need to divide by 4
				
				--also check if they are first right now
				--dont wanna be giving it if they are already first
				--yes we are going to use the k_position for this
				local spd = (speedbonus*cv_outrun_comebackmaxspeed.value)/100
				if p.kartstuff[k_position] == 1 then
					--complicated maths to get some smoothing
					local firsttics = FixedDiv(p.outrun.ticsinfirst*FRACUNIT, 2*TICRATE*FRACUNIT)
					spd = FixedDiv($, firsttics + 1*FRACUNIT)
				end

				--[[

				ang: let's use boostpower instead so it doesn't completely nullify sneakers in 12th. :please:

				--]]
				local finalSpd = FRACUNIT + spd

				--might as well make sure i don't screw my own mods over
				--i need to just write boostpersist eventually because i'm a fuckin hack
				if citytrial and p.ct_stats.booststat then finalSpd = $ + (p.ct_stats.booststat*FRACUNIT)/100 end
				if waytoofast and p.ccboost then finalSpd = $ + p.ccboost end
				if acrobatics and p.basebonus then finalSpd = $ + p.basebonus end
				--so just want to point out to anyone reading this file,
				--ang basicly just leaked their own mods in this so ha ha lol
				--if anyone complains its not my fault

				--reapply the offroad penalties 
				if p.kartstuff[k_bananadrag] > TICRATE then
					finalSpd = 4*FRACUNIT/5 --you still shouldn't be able to lawnmow
				end

				if p.kartstuff[k_offroad] > 0 and not(p.kartstuff[k_invincibilitytimer] or p.kartstuff[k_hyudorotimer] or p.kartstuff[k_sneakertimer]) then
					finalSpd = FixedDiv(min($, FRACUNIT), p.kartstuff[k_offroad] + FRACUNIT)
				end

				p.kartstuff[k_boostpower] = finalSpd 
				p.kartstuff[k_accelboost] = max($, spd*cv_outrun_comebackaccelfactor.value) --Apply accel as well - this should help make the speed change feel more significant
				comebackVfx(p, spd)

				--save the current bonus into a variable
				p.outrun.speedbonus = spd

				--remove perfect if they have it
				removePerfect(p)
			else
				p.outrun.speedbonus = 0
			end
			
		end
	end
	
	--now we do dumb with the spb noise
	if calculateTimer() == 0 and not outrun.playedovertimesound then
		S_StartSound(nil, sfx_s253)
		outrun.playedovertimesound = true
	end
end

--PlayerSpawn
local function outrunPlayerSpawn(p)
	
	if p.outrun 
	and p.valid 
	and not p.spectator 
	and outrun.running 
	and not p.exiting 
	and leveltime > STARTTIME then
		p.outrun.timer = min(max($, TICRATE*cv_outrun_minimumtimer.value) + TICRATE*cv_outrun_respawnpenalty.value, TICRATE*cv_outrun_timer.value)
		p.outrun.perfect = false
	end
	
	if outrun.running and (hud.enabled("minirankings") or hud.enabled("gametypeinfo")) then
		hud.disable("minirankings")
		hud.disable("gametypeinfo")
	end
	
	if p.valid and not p.outrun then
		resetVars(p)
	end
	
end

--IntermissionThinker
local function outrunInter()
	
	hud.enable("minirankings")
	hud.enable("gametypeinfo")
	
end

--###########
--###HOOKS###
--###########
addHook("ThinkFrame", outrunThink)
addHook("PlayerSpawn", outrunPlayerSpawn)
addHook("NetVars", netVars)
addHook("IntermissionThinker", outrunInter)

--#########
--###HUD###
--#########
local function outrunHud(v, p)
	if not outrun.running then return end
	if not p.outrun then return end
	
	for s in skins.iterate do
		if not skinRankIcons[s.name] then
			skinRankIcons[s.name] = v.cachePatch(s.facerank)
		end
	end
	if not m_norank then
		m_norank = v.cachePatch("M_NORANK")
	end
	for i=0, 9 do
		if not bignumGfx[i] then
			bignumGfx[i] = v.cachePatch("K_POSN" .. i .."0")
		end
	end
	
	do
		local bumpercol = v.getColormap(0, SKINCOLOR_GREY)
		local vflags = V_HUDTRANS|V_SNAPTOLEFT
		--first
		local icon = m_norank
		local colormap = nil
		local timestr = "--.--"
		local strcolours = 0
		if outrun.currentfirst and outrun.currentfirst.valid and not outrun.currentfirst.spectator then
			icon = skinRankIcons[outrun.currentfirst.mo.skin]
			colormap = v.getColormap(outrun.currentfirst.mo.skin, outrun.currentfirst.skincolor)
			timestr = ticsToTimeString(outrun.currentfirst.outrun.timer)
			strcolours = getStringColours(outrun.currentfirst.outrun.timer)
			
			if outrun.currentfirst.outrun.ticsinfirst >= (cv_outrun_timer.value*TICRATE)/2
			and outrun.currentfirst.outrun.perfect then
				local strcol = V_YELLOWMAP
				if (leveltime/4)%2 then
					strcol = V_ORANGEMAP
				end
				v.drawString(FIRSTXPOS+17, FIRSTYPOS-5, "CAN PERFECT", vflags|strcol, "small")
			end
		end
		v.draw(FIRSTXPOS, FIRSTYPOS+1, icon, vflags, colormap)
		v.drawString(FIRSTXPOS+17, FIRSTYPOS, "FIRST", vflags)
		v.drawString(FIRSTXPOS+17, FIRSTYPOS+10, timestr, vflags|strcolours)
		
		--leader
		icon = m_norank
		colormap = nil
		timestr = "--.--"
		strcolours = 0
		if outrun.currentleader and outrun.currentleader.valid and not outrun.currentleader.spectator then
			icon = skinRankIcons[outrun.currentleader.mo.skin]
			colormap = v.getColormap(outrun.currentleader.mo.skin, outrun.currentleader.skincolor)
			timestr = ticsToTimeString(outrun.currentleader.outrun.timer)
			strcolours = getStringColours(outrun.currentleader.outrun.timer)
			if outrun.currentleader.outrun.ticsinfirst >= (cv_outrun_timer.value*TICRATE)/2
			and outrun.currentleader.outrun.perfect then
				local strcol = V_YELLOWMAP
				if (leveltime/4)%2 then
					strcol = V_ORANGEMAP
				end
				v.drawString(LEADERXPOS+17, LEADERYPOS+20, "CAN PERFECT", vflags|strcol, "small")
			end
		end
		v.draw(LEADERXPOS, LEADERYPOS+1, icon, vflags, colormap)
		v.drawString(LEADERXPOS+17, LEADERYPOS, "LEADER", vflags)
		v.drawString(LEADERXPOS+17, LEADERYPOS+10, timestr, vflags|strcolours)
	end
	
	--draw mega number in center
	if outrun.currentfirst
	and outrun.currentfirst.valid
	and outrun.currentfirst.outrun.timer < TICRATE*10
	and not outrun.exittimer then
		local secs = (outrun.currentfirst.outrun.timer/TICRATE)+1
		local vflags = V_80TRANS
		
		if secs == 10 then --workaround to draw 2 numbers 
			v.draw(160-(bignumGfx[1].width/4), 100+(bignumGfx[1].height/2), bignumGfx[1], vflags)
			v.draw(160+(bignumGfx[0].width), 100+(bignumGfx[0].height/2), bignumGfx[0], vflags)
		else
			v.draw(160+(bignumGfx[secs].width/2), 100+(bignumGfx[secs].height/2), bignumGfx[secs], vflags)
		end
	end
	
	--draw current speed penalty
	--repurpace it for now to be the bonus instead of penialy
	if cv_outrun_comeback.value and FixedInt(p.outrun.speedbonus*100) then
		if p.kartstuff[k_position] == 1 then
			v.drawString(149, 125, "(Bonus reduced because first)", V_HUDTRANSHALF|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "thin-right")
		end
		v.drawString(62, 135, "+" .. FixedInt(p.outrun.speedbonus*100) .. "% SPD", V_HUDTRANSHALF|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "thin-right")
		v.drawString(62, 145, "+" .. FixedInt(p.outrun.speedbonus*cv_outrun_comebackaccelfactor.value*100) .. "% ACC", V_HUDTRANSHALF|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "thin-right")
	end
	
	--timer
	local ti = calculateTimer()
	if outrun.endtime ~= nil then
		ti = outrun.endtime
	end
	v.drawString(160, 175, string.format("%2d'%02d\"%02d", min(G_TicsToMinutes(ti, true), 99), G_TicsToSeconds(ti), G_TicsToCentiseconds(ti)), V_HUDTRANS|V_SNAPTOBOTTOM, "center")
	
	--sudden death
	if leveltime-STARTTIME > cv_outrun_suddendeathseconds.value*TICRATE then
		local sdtics = cv_outrun_suddendeathseconds.value*TICRATE
		local curtime = leveltime-STARTTIME
		local overtimelvl = ((curtime-sdtics)/(TICRATE*cv_outrun_suddendeathupgradeseconds.value))
		local str = "OVERTIME"
		if overtimelvl > 0 then
			if overtimelvl < 10 then
				str = OVERTIMELEVEL[min(overtimelvl, #OVERTIMELEVEL)] .. " OVERTIME"
			else
				str = "OK THIS IS STUPID"
			end
		end
		v.drawString(160, 185, str, V_REDMAP|V_HUDTRANS|V_SNAPTOBOTTOM, "center")
	else
		v.drawString(160, 185, "ROUND TIME", V_HUDTRANS|V_SNAPTOBOTTOM, "center")
	end
	
	--go for perfect string
	if p.outrun.ticsinfirst >= (cv_outrun_timer.value*TICRATE)/2
	and p.outrun.perfect
	and not outrun.exittimer then
		local strcol = V_YELLOWMAP
		if (leveltime/4)%2 then
			strcol = V_ORANGEMAP
		end
		v.drawString(160, 165, "GO FOR PERFECT!", strcol|V_HUDTRANS|V_SNAPTOBOTTOM, "center")
	end
	
	--postround animations
	if outrun.exittimer and outrun.currentleader.valid then
		v.drawString(160, 60, outrun.currentleader.name .. " WINS!", V_HUDTRANS|V_ALLOWLOWERCASE, "center")
		if outrun.exittimer >= TICRATE*2 and outrun.perfectwin then
			local textcol = PERFECTRAINBOW[((outrun.exittimer/4)%#PERFECTRAINBOW)+1]
			v.drawString(160, 80, "PERFECT", textcol|V_HUDTRANS|V_ALLOWLOWERCASE, "center")
		end
	elseif outrun.exittimer then
		v.drawString(160, 60, "They left :(", V_HUDTRANS|V_ALLOWLOWERCASE, "center")
		if outrun.exittimer >= TICRATE*2 then
			v.drawString(160, 80, "QUITALITY", V_REDMAP|V_HUDTRANS|V_ALLOWLOWERCASE, "center")
		end
	end
	
end

hud.add(outrunHud, "game")